
//Titel:        Anwendungsbeispiel fr die Message Queue  / Vector
//Version:
//Copyright:    Copyright (c) 2000
//Autor:       J.M.Joller
//Firma:      (C) J.M.Joller
//Beschreibung:  Kommunikation zweier Threads mit Hilfe einer Message Queue
package MsgQueueBsp;

import java.util.*;

class MSQThread extends Thread{

  private MessageQueue pQueue;
  private String strIn;
  private char cLTyp; // Produzent oder Konsument
  private Date dStart = new Date();
  private long lStart = dStart.getTime();

  public MSQThread(String str, MessageQueue queue, char cTyp) {
        super(str);
        strIn = str;
        pQueue = queue;
        cLTyp = cTyp;
  }
  public void run() {

    // zwei Threads in einer Klasse : Produzent und Konsument
    if (cLTyp == 'P') {
    // Produzent : lebt nur eine bestimmte Anzahl Millisekunden und erlaubt max 10 wartende Messages
      Date dStop = new Date();
      long lStop = dStop.getTime();
      while ( ((lStop - lStart) < 2000) && (pQueue.nr_messages() < 10) ) {
        int iMsg = pQueue.nr_messages()+1;
        String msg_Obj = new String(Integer.toString(iMsg)+" "+Long.toString(lStop));
        pQueue.send(msg_Obj);
        // Zeit neu bestimmen
        dStop = new Date();
        lStop = dStop.getTime();
        try {
          this.sleep(10);
        } catch (InterruptedException ie) {
          System.err.println("Fehler beim Schlafen : "+ie.getMessage());
          ie.printStackTrace();
        }
        System.out.println(strIn+" : Objekt "+msg_Obj+" wurde gesendet");
      }
    }

    if (cLTyp == 'K') {
    // Konsument : lebt nur eine bestimmte Anzahl Millisekunden; kann auch verdursten (Queue ist leer)
      Date dStop = new Date();
      long lStop = dStop.getTime();
      while ( ((lStop - lStart) < 20000) && !pQueue.is_empty() ) {
        String msg_Obj = new String((String)pQueue.recv());
        // Zeit neu bestimmen
        dStop = new Date();
        lStop = dStart.getTime();
        try {
          this.sleep(10);
        } catch (InterruptedException ie) {
          System.err.println("Fehler beim Schlafen : "+ie.getMessage());
          ie.printStackTrace();
        }
        System.out.println(strIn+" : Objekt "+msg_Obj+" wurde empfangen");
      }
    }

  }
}