
//Titel:        Observable - Observer Design Pattern
//Version:
//Copyright:    Copyright (c) 2000
//Autor:       J.M.Joller
//Firma:      (C) J.M.Joller
//Beschreibung:  Observable - Observer Design Pattern
package Observable_Observer;

import java.util.Observable;
import java.util.Observer;
import java.util.*;

class ObservableMain {
    final static int weiss = 0;
    final static int rot = 1;
    final static int blau = 2;

    public static void main(String[] args) {
        // Observable definieren
        System.out.println("Observable 'farbe' kreieren");
        FarbObservable farbe = new FarbObservable();
        Statistik zhler = new Statistik(3);

        // Observers zuordnen
        System.out.println("Observer zuordnen");
        farbe.addObserver(zhler);
        farbe.addObserver(new Echoer());
        System.out.println("Anzahl Observers: " + farbe.countObservers());

        // Observable ndern
        System.out.println("Observable ndern");
        farbe.farbeAendern(blau);
        farbe.farbeAendern(weiss);
        farbe.farbeAendern(rot);
        farbe.farbeAendern(blau);

        //    und nun das Ganze noch rein zufllig
        for (int j=0; j<10; j++) {
          farbe.farbeAendern(Random(3));
        }

        zhler.berichten();

        // entferne einen Observer
        System.out.println("Einen Observer entfernen");
        farbe.deleteObserver(zhler);
        System.out.println("Anzahl Observers: " + farbe.countObservers());
        // entferne alle Observers
        System.out.println("Alle Observer entfernen");
        farbe.deleteObservers();
        System.out.println("Anzahl Observers: " + farbe.countObservers());
    }
}