
//Titel:        Wrter zhlen
//Version:
//Copyright:    Copyright (c) 2000
//Autor:       J.M.Joller
//Firma:      (C) J.M.Joller
//Beschreibung:  Anwendungsbeispiel fr
//das Collections Framework
package WordCounter;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

import java.util.Collection;
import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;

public class WordCounter {

  Reader reader;
  PrintWriter writer;
  StreamTokenizer tokenizer;

  SortedMap wordTable;

  public WordCounter(Reader reader, PrintWriter writer) {
    this.reader = reader;
    this.writer = writer;
    tokenizer = new StreamTokenizer(reader);
    wordTable = new TreeMap();
  }

  public void print() {
    Collection c = wordTable.values();
    Iterator it = c.iterator();
    while(it.hasNext()) {
      Counter counter = (Counter)it.next();
      counter.dump();
    }
  }

  public void count() throws IOException {
    int tokenType;
    String token;
    Counter counter;

    while((tokenType = tokenizer.nextToken())
                           != StreamTokenizer.TT_EOF) {
      if (tokenType == StreamTokenizer.TT_WORD) {
        token = tokenizer.sval;
        counter = (Counter)wordTable.get(token);
        if (counter == null) {
          wordTable.put(token, new Counter(token));
        } else {
          counter.inc();
        }
      }
    }
  }

  class Counter {
    String word;
    int count;

    public Counter(String word) {
      this.word = word;
      count = 1;
    }

    public void inc() {
      count++;
    }

    public void dump() {
      // Zugriff auf Datenelement des
      // umschlieenden Exemplars
      writer.println(word+": "+count);
    }

  }

  public static void main(String[] args) throws IOException {
    if (args.length != 1) {
      System.err.println("Usage: WordCounter EingabeDatei");
    } else {
      PrintWriter writer = new PrintWriter(System.out);
      WordCounter wordCounter = new WordCounter(new FileReader(args[0]), writer);
      wordCounter.count();
      wordCounter.print();
      writer.close();
    }
  }

}
